Enum PositionMarkerColor
{
	PMC_Black   = 0,
	PMC_Red     = 1,
	PMC_Yellow  = 2,
	PMC_Green   = 3,
	PMC_Cyan    = 4,
	PMC_Blue    = 5,
	PMC_Magenta = 6,
	PMC_White   = 7
}

class FloatingNumber : Actor
{
	default
	{
		Radius 8;
		Height 43;
		+WallSprite;
		+NoInteraction;
		+NoBlockMap;
	}
	
	protected int CurrentValue;

	states
	{
		spawn:
		Number0:
			LMN1 A -1 bright;
				stop;
		Number1:
			LMN1 B -1 bright;
				stop;
		Number2:
			LMN1 C -1 bright;
				stop;
		Number3:
			LMN1 D -1 bright;
				stop;
		Number4:
			LMN1 E -1 bright;
				stop;
		Number5:
			LMN1 F -1 bright;
				stop;
		Number6:
			LMN1 G -1 bright;
				stop;
		Number7:
			LMN1 H -1 bright;
				stop;
		Number8:
			LMN1 I -1 bright;
				stop;
		Number9:
			LMN1 J -1 bright;
				stop;
		Number10:
			LMN1 K -1 bright;
				stop;
		Number11:
			LMN1 L -1 bright;
				stop;
		Number12:
			LMN1 M -1 bright;
				stop;
		Number13:
			LMN1 N -1 bright;
				stop;
		Number14:
			LMN1 O -1 bright;
				stop;
		Number15:
			LMN1 P -1 bright;
				stop;
		Number16:
			LMN1 Q -1 bright;
				stop;
		Number17:
			LMN1 R -1 bright;
				stop;
		Number18:
			LMN1 S -1 bright;
				stop;
		Number19:
			LMN1 T -1 bright;
				stop;
		Number20:
			LMN1 U -1 bright;
				stop;
		Number21:
			LMN1 V -1 bright;
				stop;
		Number22:
			LMN1 W -1 bright;
				stop;
		Number23:
			LMN1 X -1 bright;
				stop;
		Number24:
			LMN1 Y -1 bright;
				stop;
		Number25:
			LMN1 Z -1 bright;
				stop;
		Number26:
			LMN2 A -1 bright;
				stop;
		Number27:
			LMN2 B -1 bright;
				stop;
		Number28:
			LMN2 C -1 bright;
				stop;
		Number29:
			LMN2 D -1 bright;
				stop;
		Number30:
			LMN2 E -1 bright;
				stop;
		Number31:
			LMN2 F -1 bright;
				stop;
		Number32:
			LMN2 G -1 bright;
				stop;
		Number33:
			LMN2 H -1 bright;
				stop;
		Number34:
			LMN2 I -1 bright;
				stop;
		Number35:
			LMN2 J -1 bright;
				stop;
		Number36:
			LMN2 K -1 bright;
				stop;
		Number37:
			LMN2 L -1 bright;
				stop;
		Number38:
			LMN2 M -1 bright;
				stop;
		Number39:
			LMN2 N -1 bright;
				stop;
		Number40:
			LMN2 O -1 bright;
				stop;
		Number41:
			LMN2 P -1 bright;
				stop;
		Number42:
			LMN2 Q -1 bright;
				stop;
		Number43:
			LMN2 R -1 bright;
				stop;
		Number44:
			LMN2 S -1 bright;
				stop;
		Number45:
			LMN2 T -1 bright;
				stop;
		Number46:
			LMN2 U -1 bright;
				stop;
		Number47:
			LMN2 V -1 bright;
				stop;
		Number48:
			LMN2 W -1 bright;
				stop;
		Number49:
			LMN2 X -1 bright;
				stop;
		Number50:
			LMN2 Y -1 bright;
				stop;
		Number51:
			LMN2 Z -1 bright;
				stop;
		Number52:
			LMN3 A -1 bright;
				stop;
		Number53:
			LMN3 B -1 bright;
				stop;
		Number54:
			LMN3 C -1 bright;
				stop;
		Number55:
			LMN3 D -1 bright;
				stop;
		Number56:
			LMN3 E -1 bright;
				stop;
		Number57:
			LMN3 F -1 bright;
				stop;
		Number58:
			LMN3 G -1 bright;
				stop;
		Number59:
			LMN3 H -1 bright;
				stop;
		Number60:
			LMN3 I -1 bright;
				stop;
		Number61:
			LMN3 J -1 bright;
				stop;
		Number62:
			LMN3 K -1 bright;
				stop;
		Number63:
			LMN3 L -1 bright;
				stop;
		Number64:
			LMN3 M -1 bright;
				stop;
		Number65:
			LMN3 N -1 bright;
				stop;
		Number66:
			LMN3 O -1 bright;
				stop;
		Number67:
			LMN3 P -1 bright;
				stop;
		Number68:
			LMN3 Q -1 bright;
				stop;
		Number69:
			LMN3 R -1 bright;
				stop;
		Number70:
			LMN3 S -1 bright;
				stop;
		Number71:
			LMN3 T -1 bright;
				stop;
		Number72:
			LMN3 U -1 bright;
				stop;
		Number73:
			LMN3 V -1 bright;
				stop;
		Number74:
			LMN3 W -1 bright;
				stop;
		Number75:
			LMN3 X -1 bright;
				stop;
		Number76:
			LMN3 Y -1 bright;
				stop;
		Number77:
			LMN3 Z -1 bright;
				stop;
		Number78:
			LMN4 A -1 bright;
				stop;
		Number79:
			LMN4 B -1 bright;
				stop;
		Number80:
			LMN4 C -1 bright;
				stop;
		Number81:
			LMN4 D -1 bright;
				stop;
		Number82:
			LMN4 E -1 bright;
				stop;
		Number83:
			LMN4 F -1 bright;
				stop;
		Number84:
			LMN4 G -1 bright;
				stop;
		Number85:
			LMN4 H -1 bright;
				stop;
		Number86:
			LMN4 I -1 bright;
				stop;
		Number87:
			LMN4 J -1 bright;
				stop;
		Number88:
			LMN4 K -1 bright;
				stop;
		Number89:
			LMN4 L -1 bright;
				stop;
		Number90:
			LMN4 M -1 bright;
				stop;
		Number91:
			LMN4 N -1 bright;
				stop;
		Number92:
			LMN4 O -1 bright;
				stop;
		Number93:
			LMN4 P -1 bright;
				stop;
		Number94:
			LMN4 Q -1 bright;
				stop;
		Number95:
			LMN4 R -1 bright;
				stop;
		Number96:
			LMN4 S -1 bright;
				stop;
		Number97:
			LMN4 T -1 bright;
				stop;
		Number98:
			LMN4 U -1 bright;
				stop;
		Number99:
			LMN4 V -1 bright;
				stop;
	}
	
	int GetValue() {return CurrentValue;}
	
	void SetValue(int DesiredValue)
	{
		if (DesiredValue == CurrentValue) return;
		
		CurrentValue = clamp (DesiredValue, 0, 99);
		switch (CurrentValue)
		{
			case 0: SetState(ResolveState("Number0")); break;
			case 1: SetState(ResolveState("Number1")); break;
			case 2: SetState(ResolveState("Number2")); break;
			case 3: SetState(ResolveState("Number3")); break;
			case 4: SetState(ResolveState("Number4")); break;
			case 5: SetState(ResolveState("Number5")); break;
			case 6: SetState(ResolveState("Number6")); break;
			case 7: SetState(ResolveState("Number7")); break;
			case 8: SetState(ResolveState("Number8")); break;
			case 9: SetState(ResolveState("Number9")); break;
			case 10: SetState(ResolveState("Number10")); break;
			case 11: SetState(ResolveState("Number11")); break;
			case 12: SetState(ResolveState("Number12")); break;
			case 13: SetState(ResolveState("Number13")); break;
			case 14: SetState(ResolveState("Number14")); break;
			case 15: SetState(ResolveState("Number15")); break;
			case 16: SetState(ResolveState("Number16")); break;
			case 17: SetState(ResolveState("Number17")); break;
			case 18: SetState(ResolveState("Number18")); break;
			case 19: SetState(ResolveState("Number19")); break;
			case 20: SetState(ResolveState("Number20")); break;
			case 21: SetState(ResolveState("Number21")); break;
			case 22: SetState(ResolveState("Number22")); break;
			case 23: SetState(ResolveState("Number23")); break;
			case 24: SetState(ResolveState("Number24")); break;
			case 25: SetState(ResolveState("Number25")); break;
			case 26: SetState(ResolveState("Number26")); break;
			case 27: SetState(ResolveState("Number27")); break;
			case 28: SetState(ResolveState("Number28")); break;
			case 29: SetState(ResolveState("Number29")); break;
			case 30: SetState(ResolveState("Number30")); break;
			case 31: SetState(ResolveState("Number31")); break;
			case 32: SetState(ResolveState("Number32")); break;
			case 33: SetState(ResolveState("Number33")); break;
			case 34: SetState(ResolveState("Number34")); break;
			case 35: SetState(ResolveState("Number35")); break;
			case 36: SetState(ResolveState("Number36")); break;
			case 37: SetState(ResolveState("Number37")); break;
			case 38: SetState(ResolveState("Number38")); break;
			case 39: SetState(ResolveState("Number39")); break;
			case 40: SetState(ResolveState("Number40")); break;
			case 41: SetState(ResolveState("Number41")); break;
			case 42: SetState(ResolveState("Number42")); break;
			case 43: SetState(ResolveState("Number43")); break;
			case 44: SetState(ResolveState("Number44")); break;
			case 45: SetState(ResolveState("Number45")); break;
			case 46: SetState(ResolveState("Number46")); break;
			case 47: SetState(ResolveState("Number47")); break;
			case 48: SetState(ResolveState("Number48")); break;
			case 49: SetState(ResolveState("Number49")); break;
			case 50: SetState(ResolveState("Number50")); break;
			case 51: SetState(ResolveState("Number51")); break;
			case 52: SetState(ResolveState("Number52")); break;
			case 53: SetState(ResolveState("Number53")); break;
			case 54: SetState(ResolveState("Number54")); break;
			case 55: SetState(ResolveState("Number55")); break;
			case 56: SetState(ResolveState("Number56")); break;
			case 57: SetState(ResolveState("Number57")); break;
			case 58: SetState(ResolveState("Number58")); break;
			case 59: SetState(ResolveState("Number59")); break;
			case 60: SetState(ResolveState("Number60")); break;
			case 61: SetState(ResolveState("Number61")); break;
			case 62: SetState(ResolveState("Number62")); break;
			case 63: SetState(ResolveState("Number63")); break;
			case 64: SetState(ResolveState("Number64")); break;
			case 65: SetState(ResolveState("Number65")); break;
			case 66: SetState(ResolveState("Number66")); break;
			case 67: SetState(ResolveState("Number67")); break;
			case 68: SetState(ResolveState("Number68")); break;
			case 69: SetState(ResolveState("Number69")); break;
			case 70: SetState(ResolveState("Number70")); break;
			case 71: SetState(ResolveState("Number71")); break;
			case 72: SetState(ResolveState("Number72")); break;
			case 73: SetState(ResolveState("Number73")); break;
			case 74: SetState(ResolveState("Number74")); break;
			case 75: SetState(ResolveState("Number75")); break;
			case 76: SetState(ResolveState("Number76")); break;
			case 77: SetState(ResolveState("Number77")); break;
			case 78: SetState(ResolveState("Number78")); break;
			case 79: SetState(ResolveState("Number79")); break;
			case 80: SetState(ResolveState("Number80")); break;
			case 81: SetState(ResolveState("Number81")); break;
			case 82: SetState(ResolveState("Number82")); break;
			case 83: SetState(ResolveState("Number83")); break;
			case 84: SetState(ResolveState("Number84")); break;
			case 85: SetState(ResolveState("Number85")); break;
			case 86: SetState(ResolveState("Number86")); break;
			case 87: SetState(ResolveState("Number87")); break;
			case 88: SetState(ResolveState("Number88")); break;
			case 89: SetState(ResolveState("Number89")); break;
			case 90: SetState(ResolveState("Number90")); break;
			case 91: SetState(ResolveState("Number91")); break;
			case 92: SetState(ResolveState("Number92")); break;
			case 93: SetState(ResolveState("Number93")); break;
			case 94: SetState(ResolveState("Number94")); break;
			case 95: SetState(ResolveState("Number95")); break;
			case 96: SetState(ResolveState("Number96")); break;
			case 97: SetState(ResolveState("Number97")); break;
			case 98: SetState(ResolveState("Number98")); break;
			case 99: SetState(ResolveState("Number99")); break;
		}
	}
}

class PositionMarker : actor
{
	default
	{
		Height 53;
		Radius 13;
		+NoGravity
		+NoTrigger
		+NoInteraction
	}
	states
	{
		spawn:
		blue:
			LMPM B -1 bright;
			stop;
		cyan:
			LMPM C -1 bright;
			stop;
		green:
			LMPM G -1 bright;
			stop;
		magenta:
			LMPM M -1 bright;
			stop;
		black:
			LMPM N -1 bright;
			stop;
		red:
			LMPM R -1 bright;
			stop;
		white:
			LMPM W -1 bright;
			stop;
		yellow:
			LMPM Y -1 bright;
			stop;
	}

	FloatingNumber myNumber;
	
	void MarkSpot(vector3 TheSpot, int DesiredNumber = 13, PositionMarkerColor DesiredColor = PMC_Blue)
	{
		SetOrigin(TheSpot, true);
		
		//if attached to or close to the ceiling
		If (CeilingZ - Height <= TheSpot.z && TheSpot.z - FloorZ > CeilingZ - TheSpot.z)
		{
			bYFlip=true;
			TheSpot.z -= Height;
			SetOrigin(TheSpot, true);
		}
		else
		{
			bYFlip=false;
		}
		
		vector3 myNumPos = pos + (0, 0, (bYflip ? -26 : 0));
		if (!myNumber) myNumber = FloatingNumber(spawn("FloatingNumber",myNumPos));
		if (myNumber.pos != myNumPos) myNumber.SetOrigin(myNumPos, true);
		myNumber.angle = angle;
		myNumber.bWallSprite = bWallSprite;
		myNumber.SetValue(DesiredNumber);
		SetMarkerColor(DesiredColor);
	}
	
	override void OnDestroy()
	{
		console.printf("Destroy Position marker");//DEBUG
		myNumber.Destroy();
		super.OnDestroy();
	}
	
	void SetMarkerColor(PositionMarkerColor DesiredColor)
	{
		switch (DesiredColor)
		{
			case PMC_Black: SetState(ResolveState("black")); break;
			case PMC_Blue: SetState(ResolveState("blue")); break;
			case PMC_Cyan: SetState(ResolveState("cyan")); break;
			case PMC_Green: SetState(ResolveState("green")); break;
			case PMC_Magenta: SetState(ResolveState("magenta")); break;
			case PMC_Red: SetState(ResolveState("red")); break;
			case PMC_Yellow: SetState(ResolveState("yellow")); break;
			case PMC_White: SetState(ResolveState("white")); break;
			default: SetState(ResolveState("blue")); break;
		}
	}
}
